<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Validators\BannerValidator;
use App\Managers\Banner\BannerManager;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use App\Managers\Player\PlayerManager;
use App\Managers\Schedule\ScheduleManager;
use App\Managers\PlayerRatings\PlayerRatingsManager;
use App\Managers\LiveSchedulePlayers\LiveSchedulePlayersManager;
use App\Managers\Profile\ProfileManager;
use App\Http\Controllers\mobilPay\Mobilpay\Payment\Request\Mobilpay_Payment_Request_Card;
use App\Http\Controllers\mobilPay\Mobilpay\Payment\Mobilpay_Payment_Invoice;
use App\Http\Controllers\mobilPay\Mobilpay\Payment\Mobilpay_Payment_Address;
use Log;
use App\Http\Controllers\mobilPay\Mobilpay\Payment\Request\Mobilpay_Payment_Request_Abstract;
use App\Managers\Paypal\PaypalManager;
use App\Managers\BannerContainer\BannerContainerManager;
use App\Managers\PaymentParent\PaymentParentManager;
use Carbon\Carbon;
use App\Managers\PaymentID\PaymentIDManager;

use App\Managers\PlayerRatingSubstitute\PlayerRatingSubstituteManager;
use App\Managers\SchedulePlayers\SchedulePlayersManager;
use App\Managers\Substitution\SubstitutionManager;

use Illuminate\Support\Facades\DB;


class MainController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->bannerValidator = new BannerValidator();
        $this->bannerManager = new BannerManager();
        
        $this->userManager = new UserManager();
        $this->playerManager = new PlayerManager();
        
        $this->scheduleManger = new ScheduleManager();
        $this->playerRatings = new PlayerRatingsManager();
        $this->playerRatingsSubstitute = new PlayerRatingSubstituteManager();
        $this->profile = new ProfileManager();
        $this->paypalManager = new PaypalManager();
        $this->bannerContainerManager = new BannerContainerManager();
        $this->paymentParentManager = new PaymentParentManager();
        $this->paymentIDManager = new PaymentIDManager();
        $this->liveSchedulePlayerManager = new LiveSchedulePlayersManager();
        $this->schedulePlayersManager = new SchedulePlayersManager();
        $this->SubstitutionManager = new SubstitutionManager();
    }
    
    public function banner(Request $request)
    {
//        $user = $this->userManager->where('UUID', Session::get('general'))->first();
//        $userID = $user->UUID;
//        if($user->member == 0)
//        {
//            return redirect('/member');
//        }
        
        //$banners = $this->bannerManager->where('user_id', $request->session()->get('general'))->whereNull('paypal_id')->get();
        return view('main/banner');
    }
    
    public function payForBanner(Request $request)
    {
        
        $userID = $request->session()->get('general');
        
        $bannerCounts = $this->bannerManager->whereNull('paypal_id')->whereNull('banner_container_id')->count();
        $paymentAmount = $bannerCounts * 400;
        
        $bannerContainerID = $this->bannerContainerManager->insertData();
        if(!$bannerContainerID)
        {
            return redirect()->back()->withErrors(['errors' => 'Something Went Wrong']);
        }
        
        $user = $this->userManager->where('UUID', $userID)->first();
        
        #for testing purposes, all payment requests will be sent to the sandbox server. Once your account will be active you must switch back to the live server https://secure.mobilpay.ro
        #in order to display the payment form in a different language, simply add the language identifier to the end of the paymentUrl, i.e https://secure.mobilpay.ro/en for English
        $paymentUrl = config('mobilpay.mobilepay_server');
        //$paymentUrl = 'https://secure.mobilpay.ro';
        // this is the path on your server to the public certificate. You may download this from Admin -> Conturi de comerciant -> Detalii -> Setari securitate
        $x509FilePath 	= config('mobilpay.public_key_path');
        
        try
        {
            
                srand((double) microtime() * 1000000);
                
                //$objPmReqCard 					= new Mobilpay_Payment_Request_Card();
                $objPmReqCard 					= new Mobilpay_Payment_Request_Card();
                #merchant account signature - generated by mobilpay.ro for every merchant account
                #semnatura contului de comerciant - mergi pe www.mobilpay.ro Admin -> Conturi de comerciant -> Detalii -> Setari securitate
                $objPmReqCard->signature 			= config('mobilpay.merchant_id');
                #you should assign here the transaction ID registered by your application for this commercial operation
                #order_id should be unique for a merchant account
                $objPmReqCard->orderId 				= md5(uniqid(rand()));
                #below is where mobilPay will send the payment result. This URL will always be called first; mandatory
                $objPmReqCard->confirmUrl 			= url('/') . '/banner/confirm?id=' . $bannerContainerID;
                #below is where mobilPay redirects the client once the payment process is finished. Not to be mistaken for a "successURL" nor "cancelURL"; mandatory
                $objPmReqCard->returnUrl 			= url('/') . '/banner/return';
                
                $objPmReqCard->successURL 			= url('/') . '/banner/return';
                $objPmReqCard->cancelURL 			= url('/') . '/banner/failure';

                #detalii cu privire la plata: moneda, suma, descrierea
                #payment details: currency, amount, description
                $objPmReqCard->invoice = new Mobilpay_Payment_Invoice();
                #payment currency in ISO Code format; permitted values are RON, EUR, USD, MDL; please note that unless you have mobilPay permission to 
                #process a currency different from RON, a currency exchange will occur from your currency to RON, using the official BNR exchange rate from that moment
                #and the customer will be presented with the payment amount in a dual currency in the payment page, i.e N.NN RON (e.ee EUR)
                $objPmReqCard->invoice->currency	= 'RON';
                $objPmReqCard->invoice->amount		= $paymentAmount;
                #available installments number; if this parameter is present, only its value(s) will be available
                //$objPmReqCard->invoice->installments= '2,3';
                #selected installments number; its value should be within the available installments defined above
                //$objPmReqCard->invoice->selectedInstallments= '3';
                //platile ulterioare vor contine in request si informatiile despre token. Prima plata nu va contine linia de mai jos.
                $objPmReqCard->invoice->tokenId = 'token_id';
                $objPmReqCard->invoice->details		= 'cotizatie simpatizant (supporter contribution)';

                #detalii cu privire la adresa posesorului cardului
                #details on the cardholder address (optional)
                $billingAddress 			= new Mobilpay_Payment_Address();
                $billingAddress->type			= 'person'; //should be "person"
                $billingAddress->firstName		= $user->name;
                $billingAddress->lastName		= ' ';
                $billingAddress->address		= $user->address;
                $billingAddress->email			= $user->email;
                $billingAddress->mobilePhone		= $user->phone;
                $objPmReqCard->invoice->setBillingAddress($billingAddress);

                #detalii cu privire la adresa de livrare
                #details on the shipping address
                $shippingAddress 				= new Mobilpay_Payment_Address();
                $shippingAddress->type			= 'person';
                $shippingAddress->firstName		= $user->name;
                $shippingAddress->lastName		= ' ';
                $shippingAddress->address		= $user->address;
                $shippingAddress->email			= $user->email;
                $shippingAddress->mobilePhone		= $user->phone;
                
                $objPmReqCard->invoice->setShippingAddress($shippingAddress);
               
                #uncomment the line below in order to see the content of the request
             //   echo "<pre>";print_r($objPmReqCard);echo "</pre>";
                
                $objPmReqCard->encrypt($x509FilePath);
                
                
                echo '<link href="http://www.mobilpay.ro/assets/themes/public/css/screen.css" media="screen, projection" rel="stylesheet" type="text/css" />
                <link href="http://www.mobilpay.ro/assets/common/img/favicon.ico" rel="shortcut icon" />
                <link href="http://www.mobilpay.ro/assets/themes/public/css/print.css" media="print" rel="stylesheet" type="text/css" />
                <link href="http://www.mobilpay.ro/assets/themes/public/css/mp.css" media="screen" rel="stylesheet" type="text/css" />
                <link href="http://www.mobilpay.ro/assets/themes/public/css/ui.css" media="screen" rel="stylesheet" type="text/css" />';
                echo "<h3>Processing Payment</h3>";
                ?>

                    <form name="frmPaymentRedirect" method="post" id="payment_form" action="<?php echo $paymentUrl;?>">
                        <input type="hidden" name="env_key" value="<?php echo $objPmReqCard->getEnvKey();?>"/>
                        <input type="hidden" name="data" value="<?php echo $objPmReqCard->getEncData();?>"/>
                        <p>
                                Vei redirectat catre pagina de plati securizata a mobilpay.ro
                        </p>
    <!--                    <p>
                                Pentru a continua apasa <input type="image" src="images/mobilpay.gif" />
                        </p>-->
                    </form>
              <script
  src="https://code.jquery.com/jquery-2.2.4.min.js"
  integrity="sha256-BbhdlvQf/xTY9gja0Dq3HiwQF8LaCRTXxZKRutelT44="
  crossorigin="anonymous"></script>
  <script>
      $(document).ready(function(){
          $('#payment_form').submit();
      });
      </script>
              
                <?php
                
        }
        catch(\Exception $e)
        {
            echo $e->getMessage();
        }
        
        
    }
    
    function returnBannerPayment(Request $request) { 
        $orderID = $request->get('orderId');
        return view('main/payment/mobilpay_return')->with('orderID', $orderID);
    }
    
    function failureBannerPayment()
    {
        return view('main/payment/mobilpay_failure');
    }

    function confirmBannerPayment(Request $request) {
    
        if(!$request->get('id'))
        {
            die("Cannot Proceed. Something went wrong during Payment");
        }

        $bannerContainerID = $request->get('id');
        $bannerContainer = $this->bannerContainerManager->where('UUID', $bannerContainerID)->first();
       //Log::info(print_r($data));
       // dd($data);
       // dd("a");

        $errorMessage	= '';
        $errorCode = 0;
        $systemErrorCode = 0;
        $errorType		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_NONE;

            if($request->get('env_key') && $request->get('data'))
            {
                    #calea catre cheia privata
                    #cheia privata este generata de mobilpay, accesibil in Admin -> Conturi de comerciant -> Detalii -> Setari securitate
                    $privateKeyFilePath = config('mobilpay.private_key_path');

                    try
                    {
                        $objPmReq = Mobilpay_Payment_Request_Abstract::factoryFromEncrypted($request->get('env_key'), $request->get('data'), $privateKeyFilePath);
                        #uncomment the line below in order to see the content of the request
                        
                        $rrn = $objPmReq->objPmNotify->rrn;

                        // action = status only if the associated error code is zero
                        if ($objPmReq->objPmNotify->errorCode == 0) {
                            
                            $paypalExisting = $this->paypalManager->where('txn_id', $objPmReq->orderId)->where('type', 'MobilPay')->first();
                            if($paypalExisting)
                            {
                                $systemErrorCode = 1;
                                $errorMessage.= "Confirmation receiving again";
                            }
                            
                            
                            $paymentExisting = $this->paymentIDManager->where('payment_id', $objPmReq->orderId)->where('payment_gateway', 'MobilPay')->first();
                            if($paymentExisting)
                            {
                                $systemErrorCode = 1;
                                $errorMessage.= "Confirmation receiving again";
                            }
                            
                            if(isset($objPmReq->objPmNotify->errorMessage) && $objPmReq->objPmNotify->errorMessage != '')
                            {
                                $data['error_message'] = $objPmReq->objPmNotify->errorMessage;
                                $errorMessage.= $objPmReq->objPmNotify->errorMessage;;
                                //$errorCode = 1;
                            }
                            else
                            {
                                $errorType		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
                                $errorCode 		= Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_ACTION;
                                $errorMessage.= 'mobilpay_refference_action paramaters is invalid';;
                                $data['error_message'] = 'mobilpay_refference_action paramaters is invalid';
                            }
                            $data['payment_status'] = $objPmReq->objPmNotify->action;
                            $data['mc_currency'] = $objPmReq->invoice->currency;
                            $data['type'] = 'MobilPay';
                            $data['description'] = 'Banner Payment';
                            $data['mc_gross'] = $data['payment_gross'] = $objPmReq->invoice->amount;
                            $data['no_of_votes'] = 1;
                            $data['payment_date'] = date('Y-m-d H:i:s');
                            
                            $data['user_id'] = $bannerContainer->user_id;
                            $data['details'] = $objPmReq->invoice->details;
                            $data['first_name'] = $objPmReq->objPmNotify->customer->firstName;
                            $data['payer_email'] = $objPmReq->objPmNotify->customer->email;
                            $data['payer_phone'] = $objPmReq->objPmNotify->customer->mobilePhone;
                            $data['address_street'] = $objPmReq->objPmNotify->customer->address;
                            $data['txn_id'] = $objPmReq->orderId;
                            $data['expiry_date'] = date('Y-m-d', strtotime('+1 years'));
                            if($errorCode == 0 && $systemErrorCode == 0)
                            {
                                $this->paypalManager->insertBannerPayment($data, $bannerContainerID);

                                $data2['payment_id'] = $objPmReq->orderId;
                                $data2['payment_gateway'] = 'MobilPay';
                                $data2['amount'] = $objPmReq->invoice->amount;
                                $data2['user_id'] = $bannerContainer->user_id;
                                $data2['UUID'] = $this->helper->addUuid();
                                $data2['created_at'] = $data2['updated_at'] = date("Y-m-d H:i:s");

                                $this->paymentIDManager->insert($data2);
                            }
                            
                        }
                        else {
                            //update DB, SET status = "rejected"
                            $errorMessage = $objPmReq->objPmNotify->errorMessage;
                        } 

                    }
                    catch(Exception $e)
                    {
                        $errorType 		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_TEMPORARY;
                        $errorCode		= $e->getCode();
                        $errorMessage 	= $e->getMessage();
                        $data['error_message'] = $e->getMessage();
                    }
            }
            else
            {
                $errorType 		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
		$errorCode		= Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_POST_PARAMETERS;
		$errorMessage 	=       'mobilpay.ro posted invalid parameters';
            }

           

            header('Content-type: application/xml');
            echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
            if($errorCode == 0)
            {
                    echo "<crc>{$errorMessage}</crc>";
            }
            else
            {
                    echo "<crc error_type=\"{$errorType}\" error_code=\"{$errorCode}\">{$errorMessage}</crc>";
            }
    }
    
    public function member(Request $request)
    {
        if(!$request->session()->has('general') || $request->session()->get('general') == '')
        {
            return redirect('/');
            exit;
        }
        $user = $this->userManager->where('UUID', Session::get('general'))->first();
        $userID = $user->UUID;
//        if($user->member != 0)
//        {
//            return redirect('/');
//        }
        return view('main/member')->with('user_id', Session::get('general'));
    }
    
    public function memberStatus(Request $request, $status)
    {
        if(!$request->session()->has('general') || $request->session()->get('general') == '')
        {
            return redirect('/');
            exit;
        }
        $user = $this->userManager->where('UUID', Session::get('general'))->first();
        $userID = $user->UUID;
//        if($user->member != 0)
//        {
//            return redirect('/');
//        }
        return view('main/member')->with('user_id', Session::get('general'))->with('status', $status);
    }
    
    public function proposal()
    {
        $user = $this->userManager->where('UUID', Session::get('general'))->first();
       
        $userID = $user->UUID;
//        if($user->member == 0)
//        {
//            return redirect('/member');
//        }
        return view('main/proposal');
    }
    
    public function account()
    {
        $user = $this->userManager->where('UUID', Session::get('general'))->first();
        $userID = $user->UUID;
//        if($user->member == 0)
//        {
//            return redirect('/member');
//        }
        return view('main/account')->with('user', $user);
    }
    
    public function buy()
    {
        $user = $this->userManager->where('UUID', Session::get('general'))->first();
        $userID = $user->UUID;
//        if($user->member == 0)
//        {
//            return redirect('/member');
//        }
        $players = $this->playerManager->get();
        return view('main/buy')->with('players', $players);
    }
    
    public function decisionProposal()
    {
        $user = $this->userManager->where('UUID', Session::get('general'))->first();
        $userID = $user->UUID;
//        if($user->member == 0)
//        {
//            return redirect('/member');
//        }
        return view('main/decision/proposal');
    }
    
    public function playerEvaluation()
    {
        $lastestSchedule = $this->scheduleManger->whereDate('date_date', '<=', date("Y-m-d"))->orderBy('date_date', 'DESC')->orderBy('time_time', 'DESC')->first();
        if(!$lastestSchedule)
        {
            return redirect('/');
            exit;
        }
        $now = time(); // or your date as well
        $your_date = strtotime($lastestSchedule->date_date);
        $datediff = $now - $your_date;
        
        $differenceDays = floor($datediff / (60 * 60 * 24));
        if($differenceDays > 3)
        {
            return redirect('/tactics/player/evaluation/results');
            //return redirect('/');
            exit;
        }
        $players = $this->playerManager->with('playerPosition')->orderBy('name')->get();
        $profile = $this->profile->first();
        return view('main/tactics/player_evaluation')->with('players', $players)->with('UUID', $lastestSchedule->UUID)->with('name', $lastestSchedule->name)->with('result', $lastestSchedule->result)->with('profile', $profile);
    }
    
    public function playerEvaluationResults()
    {
        $lastestSchedule = $this->scheduleManger->with('sub1', 'sub2', 'sub3', 'sub4', 'sub5')->whereDate('date_date', '<=', date("Y-m-d"))->orderBy('date_date', 'DESC')->orderBy('time_time', 'DESC')->first();
       
        if(!$lastestSchedule)
        {
            return redirect('/');
            exit;
        }
        
        $now = time(); // or your date as well
        $your_date = strtotime($lastestSchedule->date_date);
        $datediff = $now - $your_date;

        $differenceDays = floor($datediff / (60 * 60 * 24));
        if($differenceDays > 3)
        {
            //return redirect('/');
            //exit;
        }
        if(isset($lastestSchedule->sub1->name))
        {
            $sub1 = $lastestSchedule->sub1->name;
        }
        else
        {
            $sub1 = '';
        }
        
        if(isset($lastestSchedule->sub2->name))
        {
            $sub2 = $lastestSchedule->sub2->name;
        }
        else
        {
            $sub2 = '';
        }
        
        if(isset($lastestSchedule->sub3->name))
        {
            $sub3 = $lastestSchedule->sub3->name;
        }
        else
        {
            $sub3 = '';
        }

        if(isset($lastestSchedule->sub4->name))
        {
            $sub4 = $lastestSchedule->sub4->name;
        }
        else
        {
            $sub4 = '';
        }

        if(isset($lastestSchedule->sub5->name))
        {
            $sub5 = $lastestSchedule->sub5->name;
        }
        else
        {
            $sub5 = '';
        }
        
        $players = $this->playerManager->with('playerPosition')->orderBy('name')->get();
        $profile = $this->profile->first();

       
        return view('main/tactics/player_evaluation_results')->with('players', $players)->with('UUID', $lastestSchedule->UUID)->with('name', $lastestSchedule->name)
                                                            ->with('sub1', $sub1)->with('sub2', $sub2)->with('sub3', $sub3)
                                                            ->with('sub4', $sub4)->with('sub5', $sub5)
                                                            ->with('profile', $profile)->with('result', $lastestSchedule->result);
    }
    
    public function tactics()
    {
        $players = $this->playerManager->with('playerPosition','multiple_positions.position')->orderBy('name')->get();
        
        $profile = $this->profile->first();
        return view('main/tactics/index')->with('players', $players)->with('profile', $profile);
    }
    
    public function tacticsResults()
    {
        //$players = $this->playerManager->with('multiple_positions')->orderBy('name')->get();
        $profile = $this->profile->first();
        return view('main/tactics/results')->with('profile', $profile);
    }
    
    public function players()
    {
        $players = $this->playerManager->with('multiple_positions')->orderBy('name')->get();
        return view('main/player/index')->with('players', $players);
    }

    public function getCurrentPlayerRating($UUID)
    {
        $statistics = $this->playerRatings->getPlayerRatingForEachSchedule($UUID, 6);
        
        $scheduleSub1 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_1)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_1', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub2 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_2)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_2', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub3 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_3)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_3', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub4 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_4)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_4', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub5 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_5)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_5', $UUID)->groupBy('schedule.UUID')->get();

       
        $statisticsArray = array();
        $nameArray = array();
        $count = 0;
        $totalRating = 0;

        foreach($statistics AS $each)
        {
            $totalRating+= $each['rating_count'];
            $statisticsArray[] = round($each['rating_count'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub1 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub2 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub3 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub4 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub5 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }


        $player = $this->playerManager->with('playerPosition', 'multiple_positions')->where('UUID', $UUID)->first();
        //$playerRating = $this->playerRatings->getPlayerRating($UUID);
        if($count > 0)
        {
            $playerRating = $totalRating / $count;
        }
        else
        {
            $playerRating = 0;
        }

        return response()->json($playerRating, 200);
    }
    
    public function currentPlayer($UUID)
    {
        $statistics = $this->playerRatings->getPlayerRatingForEachSchedule($UUID, 6);
        
        $scheduleSub1 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_1)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_1', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub2 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_2)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_2', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub3 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_3)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_3', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub4 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_4)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_4', $UUID)->groupBy('schedule.UUID')->get();

        $scheduleSub5 = $this->scheduleManger->select(DB::raw('SUM(player_ratings_substitute.sub_5)/COUNT(*) as total_sub_rating'), 'schedule.name')->join('player_ratings_substitute', 'schedule.UUID', '=', 'player_ratings_substitute.scheduled_id')->where('schedule.new_player_5', $UUID)->groupBy('schedule.UUID')->get();

       
        $statisticsArray = array();
        $nameArray = array();
        $count = 0;
        $totalRating = 0;

        foreach($statistics AS $each)
        {
            $totalRating+= $each['rating_count'];
            $statisticsArray[] = round($each['rating_count'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub1 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub2 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub3 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub4 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }

        foreach($scheduleSub5 AS $each)
        {
            $totalRating+= $each['total_sub_rating'];
            $statisticsArray[] = round($each['total_sub_rating'],2);
            $nameArray[] = $each['name'];
            $count++;
        }


        $player = $this->playerManager->with('playerPosition', 'multiple_positions')->where('UUID', $UUID)->first();
        //$playerRating = $this->playerRatings->getPlayerRating($UUID);
        if($count > 0)
        {
            $playerRating = $totalRating / $count;
        }
        else
        {
            $playerRating = 0;
        }
      
        return view('main/player/show')->with('player', $player)->with('rating', $playerRating)->with('statistics',$statisticsArray)->with('name', $nameArray);
        
//        $statistics = $this->playerRatings->getPlayerRatingForEachSchedule($UUID, 6);
//        $statisticsArray = array();
//        $nameArray = array();
//        foreach($statistics AS $each)
//        {
//            $statisticsArray[] = $each['rating_count'];
//            $nameArray[] = $each['name'];
//        }
//        
//        
//        $playerRatings = $this->playerRatings->getPlayerRatinsForEachScheuleRaw($UUID);
//        $scheduledPlayerRatingsSub1 = $this->playerRatingsSubstitute->getPlayerRatinsForEachScheuleRawSub1($UUID);
//        $scheduledPlayerRatingsSub2 = $this->playerRatingsSubstitute->getPlayerRatinsForEachScheuleRawSub2($UUID);
//        $scheduledPlayerRatingsSub3 = $this->playerRatingsSubstitute->getPlayerRatinsForEachScheuleRawSub3($UUID);
//       
//        
//        $matchesNamesArray = array();
//        $matchesRatingsArray = array();
//        
//        $count = 0;
//        $totalRatings = 0;
//        $matchesCount = array();
//        foreach($playerRatings AS $playerRating)
//        {
//            $count++;
//            $totalRatings+= $playerRating->rating;
//            
//            if(!isset($matchesNamesArray[$playerRating->UUID]))
//            {
//                $matchesNamesArray[$playerRating->UUID] = $playerRating->name;
//                $matchesRatingsArray[$playerRating->UUID]['rating'] = $playerRating->rating;
//                $matchesRatingsArray[$playerRating->UUID]['count'] = 1;
//            }
//            else
//            {
//                $matchesRatingsArray[$playerRating->UUID]['rating']+= $playerRating->rating;
//                $matchesRatingsArray[$playerRating->UUID]['count']++;
//            }
//        }
//       
//        if(!empty($getPlayerRatinsForEachScheuleRawSub1))
//        foreach($getPlayerRatinsForEachScheuleRawSub1 AS $sub1)
//        {
//            $count++;
//            $totalRatings+= $sub1->sub_1;
//            
//            if(!isset($matchesNamesArray[$playerRating->UUID]))
//            {
//                $matchesNamesArray[$playerRating->UUID] = $sub1->name;
//                $matchesRatingsArray[$playerRating->UUID]['rating'] = $sub1->sub_1;
//                $matchesRatingsArray[$playerRating->UUID]['count'] = 1;
//            }
//            else
//            {
//                $matchesRatingsArray[$playerRating->UUID]['rating']+= $sub1->sub_1;
//                $matchesRatingsArray[$playerRating->UUID]['count']++;
//            }
//        }
//        
//        if(!empty($getPlayerRatinsForEachScheuleRawSub2))
//        foreach($getPlayerRatinsForEachScheuleRawSub2 AS $sub2)
//        {
//            $count++;
//            $totalRatings+= $sub2->sub_2;
//            
//            if(!isset($matchesNamesArray[$playerRating->UUID]))
//            {
//                $matchesNamesArray[$playerRating->UUID] = $sub1->name;
//                $matchesRatingsArray[$playerRating->UUID]['rating'] = $sub1->sub_2;
//                $matchesRatingsArray[$playerRating->UUID]['count'] = 1;
//            }
//            else
//            {
//                $matchesRatingsArray[$playerRating->UUID]['rating']+= $sub1->sub_2;
//                $matchesRatingsArray[$playerRating->UUID]['count']++;
//            }
//        }
//        
//        if(!empty($getPlayerRatinsForEachScheuleRawSub3))
//        foreach($getPlayerRatinsForEachScheuleRawSub3 AS $sub3)
//        {
//            $count++;
//            $totalRatings+= $sub3->sub_3;
//            
//            if(!isset($matchesNamesArray[$playerRating->UUID]))
//            {
//                $matchesNamesArray[$playerRating->UUID]  = $sub1->name;
//                $matchesRatingsArray[$playerRating->UUID]['rating'] = $sub1->sub_3;
//                $matchesRatingsArray[$playerRating->UUID]['count'] = 1;
//            }
//            else
//            {
//                $matchesRatingsArray[$playerRating->UUID]['rating']+= $sub1->sub_3;
//                $matchesRatingsArray[$playerRating->UUID]['count']++;
//            }
//        }
//        
//        $matchesNamesArray1 = array();
//        foreach($matchesNamesArray AS $each1)
//        {
//            $matchesNamesArray1[] = $each1;
//        }
//        
//        $matchesRatingsArray1 = array();
//        foreach($matchesRatingsArray AS $each1)
//        {
//            $matchesRatingsArray1[] = $each1['rating'] / $each1['count'];
//        }
//        
//        $averageRating = round($totalRatings / $count,2);
//        
//        $player = $this->playerManager->with('playerPosition', 'multiple_positions')->where('UUID', $UUID)->first();
//        $playerRating = $this->playerRatings->getPlayerRating($UUID);
//      
//        return view('main/player/show')->with('player', $player)->with('rating', $playerRating)->with('statistics',$statisticsArray)->with('name', $nameArray)->with('averageRating', $averageRating)
//                                        ->with('matchesNamesArray', $matchesNamesArray1)->with('matchesRatingsArray', $matchesRatingsArray1);
    }
    
    public function votes(Request $request)
    {
        $userID = $request->session()->get('general');
        $votes = $this->paypalManager->getTotalVoteCount($userID);
        return view('main/votes/index')->with('user_id', $userID)->with('votes', $votes);
    }
    
    public function payForVotes(Request $request, $count, $noOfVotes)
    {
        if(!is_numeric($noOfVotes) || floor( $noOfVotes ) != $noOfVotes)
        {
            return redirect()->back()->withErrors(['Please enter valid No. Of Votes']);
        }
        $currentVotesNumber = $this->paypalManager->getTotalVoteCount($request->session()->get('general'));
        if(($currentVotesNumber < 1 && $count == 4) || ($currentVotesNumber < $noOfVotes && $count == 4))
        {
            return redirect()->back()->withErrors(['You cannot proceed with this operation. You donot have ' . $currentVotesNumber . ' number of votes.']);
        }
        
        $userID = $request->session()->get('general');
        switch($count)
        {
            case 1:
                $paymentAmount = 400 * $noOfVotes;
                break;
                
            case 2:
                $paymentAmount = 220 * $noOfVotes;
                break;
                
            case 3:
                $paymentAmount = 120 * $noOfVotes;
                break;
                    
            case 4:
                $paymentAmount = 40 * $noOfVotes;
                break;
            
            case 5:
                $paymentAmount = 39 * $noOfVotes;
                break;
                
            default:
                return redirect()->back();
                break;
        }
        
        $parentArray = array();
        $parentArray['UUID'] = $this->helper->addUuid();     
        $parentArray['type'] = 'mobilPay';
        $parentArray['amount'] = $paymentAmount;
        $parentArray['no_of_votes'] = $noOfVotes;
        $parentArray['user_id'] = $userID;
        $parentArray['created_at'] = $parentArray['updated_at'] = date("Y-m-d H:i:s");
        
        $paymentParentID = $this->paymentParentManager->insertGetId($parentArray);
        if(!$paymentParentID)
        {
            return redirect()->back()->withErrors(['Something Went Wrong']);
        }
        
        $paymentParent = $this->paymentParentManager->where('id', $paymentParentID)->first();
        
        $user = $this->userManager->where('UUID', $userID)->first();
        
        #for testing purposes, all payment requests will be sent to the sandbox server. Once your account will be active you must switch back to the live server https://secure.mobilpay.ro
        #in order to display the payment form in a different language, simply add the language identifier to the end of the paymentUrl, i.e https://secure.mobilpay.ro/en for English
        $paymentUrl = config('mobilpay.mobilepay_server');
        //$paymentUrl = 'https://secure.mobilpay.ro';
        // this is the path on your server to the public certificate. You may download this from Admin -> Conturi de comerciant -> Detalii -> Setari securitate
        $x509FilePath 	= config('mobilpay.public_key_path');
        
        try
        {
                srand((double) microtime() * 1000000);
                
                //$objPmReqCard 					= new Mobilpay_Payment_Request_Card();
                $objPmReqCard 					= new Mobilpay_Payment_Request_Card();
                #merchant account signature - generated by mobilpay.ro for every merchant account
                #semnatura contului de comerciant - mergi pe www.mobilpay.ro Admin -> Conturi de comerciant -> Detalii -> Setari securitate
                $objPmReqCard->signature 			= config('mobilpay.merchant_id');
                #you should assign here the transaction ID registered by your application for this commercial operation
                #order_id should be unique for a merchant account
                $objPmReqCard->orderId 				= md5(uniqid(rand()));
                #below is where mobilPay will send the payment result. This URL will always be called first; mandatory
                $objPmReqCard->confirmUrl 			= url('/') . '/mobilpay/confirm?id=' . $paymentParent->UUID;
                #below is where mobilPay redirects the client once the payment process is finished. Not to be mistaken for a "successURL" nor "cancelURL"; mandatory
                $objPmReqCard->returnUrl 			= url('/') . '/mobilpay/return';
                
                $objPmReqCard->successURL 			= url('/') . '/mobilpay/return';
                $objPmReqCard->cancelURL 			= url('/') . '/mobilpay/cancel';

                #detalii cu privire la plata: moneda, suma, descrierea
                #payment details: currency, amount, description
                $objPmReqCard->invoice = new Mobilpay_Payment_Invoice();
                #payment currency in ISO Code format; permitted values are RON, EUR, USD, MDL; please note that unless you have mobilPay permission to 
                #process a currency different from RON, a currency exchange will occur from your currency to RON, using the official BNR exchange rate from that moment
                #and the customer will be presented with the payment amount in a dual currency in the payment page, i.e N.NN RON (e.ee EUR)
                $objPmReqCard->invoice->currency	= 'RON';
                $objPmReqCard->invoice->amount		= $paymentAmount;
                #available installments number; if this parameter is present, only its value(s) will be available
                //$objPmReqCard->invoice->installments= '2,3';
                #selected installments number; its value should be within the available installments defined above
                //$objPmReqCard->invoice->selectedInstallments= '3';
                //platile ulterioare vor contine in request si informatiile despre token. Prima plata nu va contine linia de mai jos.
                $objPmReqCard->invoice->tokenId = 'token_id';
                $objPmReqCard->invoice->details		= 'cotizatie simpatizant (supporter contribution)';

                #detalii cu privire la adresa posesorului cardului
                #details on the cardholder address (optional)
                $billingAddress 			= new Mobilpay_Payment_Address();
                $billingAddress->type			= 'person'; //should be "person"
                $billingAddress->firstName		= $user->name;
                $billingAddress->lastName		= ' ';
                $billingAddress->address		= $user->address;
                $billingAddress->email			= $user->email;
                $billingAddress->mobilePhone		= $user->phone;
                $objPmReqCard->invoice->setBillingAddress($billingAddress);

                #detalii cu privire la adresa de livrare
                #details on the shipping address
                $shippingAddress 				= new Mobilpay_Payment_Address();
                $shippingAddress->type			= 'person';
                $shippingAddress->firstName		= $user->name;
                $shippingAddress->lastName		= ' ';
                $shippingAddress->address		= $user->address;
                $shippingAddress->email			= $user->email;
                $shippingAddress->mobilePhone		= $user->phone;
                
                $objPmReqCard->invoice->setShippingAddress($shippingAddress);
               
                #uncomment the line below in order to see the content of the request
             //   echo "<pre>";print_r($objPmReqCard);echo "</pre>";
                
                $objPmReqCard->encrypt($x509FilePath);
                
                
                echo '<link href="http://www.mobilpay.ro/assets/themes/public/css/screen.css" media="screen, projection" rel="stylesheet" type="text/css" />
                <link href="http://www.mobilpay.ro/assets/common/img/favicon.ico" rel="shortcut icon" />
                <link href="http://www.mobilpay.ro/assets/themes/public/css/print.css" media="print" rel="stylesheet" type="text/css" />
                <link href="http://www.mobilpay.ro/assets/themes/public/css/mp.css" media="screen" rel="stylesheet" type="text/css" />
                <link href="http://www.mobilpay.ro/assets/themes/public/css/ui.css" media="screen" rel="stylesheet" type="text/css" />';
                echo "<h3>Processing Payment</h3>";
                ?>

                    <form name="frmPaymentRedirect" method="post" id="payment_form" action="<?php echo $paymentUrl;?>">
                        <input type="hidden" name="env_key" value="<?php echo $objPmReqCard->getEnvKey();?>"/>
                        <input type="hidden" name="data" value="<?php echo $objPmReqCard->getEncData();?>"/>
                        <p>
                                Vei redirectat catre pagina de plati securizata a mobilpay.ro
                        </p>
    <!--                    <p>
                                Pentru a continua apasa <input type="image" src="images/mobilpay.gif" />
                        </p>-->
                    </form>
              <script
  src="https://code.jquery.com/jquery-2.2.4.min.js"
  integrity="sha256-BbhdlvQf/xTY9gja0Dq3HiwQF8LaCRTXxZKRutelT44="
  crossorigin="anonymous"></script>
  <script>
      $(document).ready(function(){
          $('#payment_form').submit();
      });
      </script>
              
                <?php
                
        }
        catch(\Exception $e)
        {
            echo $e->getMessage();
        }
        
//        if(!($e instanceof \Exception)){?>
        
        <!--
        <script type="text/javascript" language="javascript">
                window.setTimeout(document.frmPaymentRedirect.submit(), 5000);
        </script> -->
        <?php 
        /*
        }else{
         */ 
         ?>
         
        <p><strong>
            
            <?php 
          //  echo $e->getMessage();
            ?>
            </strong></p>
        <?php 
        
        //};
////        Mobilpay::setOrderId(1)
////        ->setAmount($paymentAmount)
////        ->setDetails('Payment For Rsms.ro')
////        ->purchase();
//        
//        //return view('main/votes/pay')->with('user_id', $userID)->with('amount', $paymentAmount);
//    
    }
    
    function failureMobilPay()
    {
        return view('main/payment/mobilpay_failure');
    }
    
function returnMobilPay(Request $request) { 
    $orderID = $request->get('orderId');
    return view('main/payment/mobilpay_return')->with('orderID', $orderID);
}

function confirmMobilPay(Request $request) { 
    
    if(!$request->get('id'))
    {
        die("Cannot Proceed. Something went wrong during Payment");
    }
    
    $paymentParentID = $request->get('id');
    
    $paymentParent = $this->paymentParentManager->where('UUID', $paymentParentID)->first();
    if(!$paymentParent)
    {
        exit;
    }
    
    
    //Log::info($data);
   // dd($data);
   // dd("a");
    $errorCode 		= 0;
    $errorType		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_NONE;
    $errorMessage	= '';
    $systemErrorCode = 0;

//    if (strcasecmp($_SERVER['REQUEST_METHOD'], 'post') == 0)
//    {
            if($request->get('env_key') && $request->get('data'))
            {
                    #calea catre cheia privata
                    #cheia privata este generata de mobilpay, accesibil in Admin -> Conturi de comerciant -> Detalii -> Setari securitate
                    $privateKeyFilePath = config('mobilpay.private_key_path');

                    try
                    {
                        $objPmReq = Mobilpay_Payment_Request_Abstract::factoryFromEncrypted($request->get('env_key'), $request->get('data'), $privateKeyFilePath);
                        #uncomment the line below in order to see the content of the request
                        //print_r($objPmReq);
                        //Log::info(print_r($objPmReq, true));
                       // dd("a");
                        $rrn = $objPmReq->objPmNotify->rrn;


                        // action = status only if the associated error code is zero
                        if ($objPmReq->objPmNotify->errorCode == 0) {
                            if(isset($objPmReq->objPmNotify->errorMessage) && $objPmReq->objPmNotify->errorMessage != '')
                            {
                                $errorMessage.= $objPmReq->objPmNotify->errorMessage;
                                $data['error_message'] = $objPmReq->objPmNotify->errorMessage;
                                
                                if($objPmReq->objPmNotify->action != 'confirmed')
                                {
                                    $errorCode = 1;
                                }
                            }
                            else
                            {
                                $errorType		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
                                $errorCode 		= Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_ACTION;
                                $errorMessage.= 'mobilpay_refference_action paramaters is invalid';;
                                $data['error_message'] = 'mobilpay_refference_action paramaters is invalid';
                            }
                            $data['payment_status'] = $objPmReq->objPmNotify->action;
                            $data['mc_currency'] = $objPmReq->invoice->currency;
                            $data['type'] = 'MobilPay';
                            $data['mc_gross'] = $data['payment_gross'] = $objPmReq->invoice->amount;
                            $noOfVotes = $paymentParent->no_of_votes;
                            $data['payment_date'] = date('Y-m-d H:i:s');
                            
                            $data['user_id'] = $paymentParent->user_id;
                            $data['details'] = $objPmReq->invoice->details;
                            $data['first_name'] = $objPmReq->objPmNotify->customer->firstName;
                            $data['payer_email'] = $objPmReq->objPmNotify->customer->email;
                            $data['payer_phone'] = $objPmReq->objPmNotify->customer->mobilePhone;
                            $data['address_street'] = $objPmReq->objPmNotify->customer->address;
                            $data['txn_id'] = $objPmReq->orderId;
                            Log::info($data);
                            $paypalExisting = $this->paypalManager->where('txn_id', $objPmReq->orderId)->where('type', 'MobilPay')->first();
                            if($paypalExisting)
                            {
                                $systemErrorCode = 1;
                                $errorMessage.= "Confirmation receiving again";
                            }
                            
                            
                            $paymentExisting = $this->paymentIDManager->where('payment_id', $objPmReq->orderId)->where('payment_gateway', 'MobilPay')->first();
                            if($paymentExisting)
                            {
                                $systemErrorCode = 1;
                                $errorMessage.= "Confirmation receiving again";
                            }
                            
                            
                           
                            $singleAmount = $paymentParent['amount'] / $paymentParent['no_of_votes'];
                            Log::info($singleAmount . '<br/>');
                            switch($singleAmount)
                            {
                                case 400:
                                    $extensionDays = 364;
                                    $data['expiry_date'] = date('Y-m-d', strtotime('+364 days'));
                                    break;

                                case 220:
                                    $extensionDays = 182;
                                    $data['expiry_date'] = date('Y-m-d', strtotime('+182 days'));
                                    break;

                                case 120:
                                    $extensionDays = 91;
                                    $data['expiry_date'] = date('Y-m-d', strtotime('+91 days'));
                                    break;
                                
                                case 39:
                                    $extensionDays = 30;
                                    $data['expiry_date'] = date('Y-m-d', strtotime('+30 days'));
                                    break;

                                case 40:
                                    $extensionDays = 30;
                                    $count = 0;
                                    if($systemErrorCode == 0 && $errorCode == 0)
                                    {
                                        for($i = 1; $i <= $noOfVotes; $i++)
                                        {
                                            $pay = $this->paypalManager->where('user_id', $paymentParent->user_id)->whereDate('expiry_date', '>=', Carbon::now())->where('no_of_votes', 1)->orderBy('expiry_date')->first();

                                            if($pay)
                                            {
                                                $data1['expiry_date'] = date('Y-m-d', strtotime('+' . $extensionDays . ' days', strtotime($pay->expiry_date)));
                                                $data1['description'] = $pay->description . '<br/>' . 'Added 1 month on ' . $data['payment_date'] . '. <br/>Payment: ' . $data['mc_gross'] . ' ' . $data['mc_currency'] . ' through MobilPay.<br/> No. of Votes: 1.<br/> Transaction ID: ' . $data['txn_id'] . '.<br/> Payment Status: ' . $data['payment_status'] . '<br/><br/><br/>';


                                                $this->paypalManager->where('UUID', $pay->UUID)->update($data1);
                                            }
                                            $count++;
                                        }
                                    }
                                    
                                    
                                    break;

                                default:
                                    die();
                                    break;
                            }
                            
                            $data['no_of_votes'] = 1;
                            $data['expiry_date'] = date('Y-m-d', strtotime('+' . $extensionDays . ' days'));
                            if($systemErrorCode == 0 && $errorCode == 0)
                            {
                                $data2['payment_id'] = $objPmReq->orderId;
                                $data2['payment_gateway'] = 'MobilPay';
                                $data2['amount'] = $objPmReq->invoice->amount;
                                $data2['user_id'] = $paymentParent->user_id;
                                $data2['UUID'] = $this->helper->addUuid();
                                $data2['created_at'] = $data2['updated_at'] = date("Y-m-d H:i:s");

                                $this->paymentIDManager->insert($data2);
                                if($singleAmount !=1 && $singleAmount != 40)
                                {
                                    for($i = 0; $i < $noOfVotes; $i++)
                                    {
                                        $this->paypalManager->insertMobilPay($data);
                                    }
                                }
                            }
                            Log::info('System Error Code:' . $systemErrorCode . '. Error Code:' . $errorCode);
                            
                        }
                        else {
                            //update DB, SET status = "rejected"
                            $errorMessage = $objPmReq->objPmNotify->errorMessage;
                        } 
                    }
                    catch(Exception $e)
                    {
                            $errorType 		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_TEMPORARY;
                            $errorCode		= $e->getCode();
                            $errorMessage 	= $e->getMessage();
                            $data['error_message'] = $e->getMessage();
                    }
                    
            }
            else
            {
                $errorType 		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
		$errorCode		= Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_POST_PARAMETERS;
		$errorMessage 	=       'mobilpay.ro posted invalid parameters';
            }
            
            
           
            header('Content-type: application/xml');
            echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
            if($errorCode == 0)
            {
                    echo "<crc>{$errorMessage}</crc>";
            }
            else
            {
                    echo "<crc error_type=\"{$errorType}\" error_code=\"{$errorCode}\">{$errorMessage}</crc>";
            }
//            else
//            {
//                    $errorType 		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
//                    $errorCode		= Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_POST_PARAMETERS;
//                    $errorMessage 	= 'mobilpay.ro posted invalid parameters';
//            }
//    }
//    else 
//    {
//            $errorType 		= Mobilpay_Payment_Request_Abstract::CONFIRM_ERROR_TYPE_PERMANENT;
//            $errorCode		= Mobilpay_Payment_Request_Abstract::ERROR_CONFIRM_INVALID_POST_METHOD;
//            $errorMessage 	= 'invalid request metod for payment confirmation';
//    }

    
}
    
    public function live()
    {
        return view('main/live');
    }
    
    public function allVotes(Request $request)
    {
        $userID = $request->session()->get('general');
        $votes = $this->paypalManager->where('user_id', $userID)->whereDate('expiry_date', '>=', Carbon::now())->orderBy('expiry_date')->get();
        return view('main/votes/all')->with('votes', $votes);
    }

    public function voteForSubstitution(Request $request)
    {
        $currentTime = date("Y-m-d H:i:s");
        $schedule = $this->scheduleManger->where('start_time', '<=', $currentTime)->where('end_time', '>=', $currentTime)->first();
        $players = array();
        /*$allPlayers = array();
        $players = array();
        $playersArray = array();
        $notPlayers = array(); */

        if(!$schedule)
        {
            return redirect('/vote_for_substitution/results');
        }
        if($schedule)
        {

        $players = $this->playerManager->select('player.*')->with('playerPosition','multiple_positions.position')->join('substitutions', 'substitutions.player_id', '=', 'player.UUID')->where('substitutions.schedule_id', $schedule->UUID)->orderBy('name')->get();
        //$players = $this->playerManager->with('playerPosition')->orderBy('name')->get();
            /*$players = $this->schedulePlayersManager->with('player')->where('schedule_id', $schedule->UUID)->where('deleted_at', NULL)->get();
            
            if(!empty($players))
            foreach($players AS $player)
            {
                $playersArray[] = $player->player->UUID;
            }
            $notPlayers = $this->SubstitutionManager->with('player')->where('schedule_id', $schedule->UUID)->get();*/
        }

        
        $profile = $this->profile->first();
        return view('main/vote_for_substitution')->with('schedule', $schedule)->with('players', $players)->with('profile', $profile);
    }

    public function substitutionResults()
    {
        $currentTime = date("Y-m-d H:i:s");
        $schedule = $this->scheduleManger->where('start_time', '<=', $currentTime)->where('end_time', '>=', $currentTime)->first();
        if(!$schedule)
        {
            $schedule = $this->scheduleManger->where('start_time', '<=', $currentTime)->orderBy('start_time', 'DESC')->first();
            
        }

        if(!$schedule)
        {
           return view('main/schedule_not_fpund');
           exit;
        }
        return redirect('/matches/' . $schedule['UUID'] . '/substitution');
    }
}