<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Managers\Contact\ContactManager;
use App\Validators\ContactValidator;
use Illuminate\Support\Facades\Mail;

class StaticController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->contact = new ContactManager();
        $this->contactValidator = new ContactValidator();
    }
    
    public function contact()
    {
        $contact = $this->contact->first();
        return view('main/contact')->with('contact', $contact);
    }
    
    public function sendContact(Request $request)
    {
        $data = $request->get('data');
        $validation = $this->contactValidator->send($data);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
       
        Mail::send('emails.contact', ['email' => $data['email'], 'first_name' => $data['first_name'], 'second_name' => $data['second_name'], 'message1' => $data['message'],'phone'=>$data['phone'],'url' => url('/')], function ($m) use ($data) {
            $m->from('info@realclubmanager.com', 'Real Club Manager');
            $m->to('contact@realclubmanager.com', 'Real Club Manager')->subject('Real Club Manager - New Contact');
        });
        
        // check for failures
        if (Mail::failures()) {
            return response()->json(['Message Not Sent'], 500);
            exit;
        }
        
        return response()->json(['Message Sent Successfully'], 200);
            exit;
    }
    
    public function terms()
    {
        return view('main/terms');
    }
}

