<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/
namespace App\Http\Middleware;

use Closure;

use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Redirect;
use App\Managers\User\UserManager;
use App\Managers\Paypal\PaypalManager;

class GeneralAccessVotesMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $this->user = new UserManager();
        $this->paypal = new PaypalManager();
        if($request->session()->has('general') && $request->session()->get('general') != '')
        {
            $id = $request->session()->get('general');
            $user = $this->user->where('uuid', $id)->first();
            $paypal = $this->paypal->getAllCreditsOfUserBYExpiryDate($id);
        
            $totalUsers = $this->user->getTotalUsersCount();
            
            Session::put('total_users', $totalUsers['total']);
            
            $totalVotes = $this->paypal->getTotalVotesCount();
            
            
            Session::put('total_votes', $totalVotes['total']);
            
            $count = 0;
            $votes = array();
            $totalNoOfVotes = 0;
            foreach($paypal AS $each)
            {
                $votes[$count]['no_of_votes'] = $each['total_votes'];
                $votes[$count]['expiry'] = $each['expiry_date'];
                $totalNoOfVotes+= $each['total_votes'];
                $count++;
            }
         
            Session::put('votes', $votes);
            
//            if($totalNoOfVotes == 0)
//            {
//                return redirect('/votes');
//                exit;
//            }
            return $next($request);
        }
        return redirect('/auth/login');
    }
}
