<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/
namespace App\Validators\Admin;
use Illuminate\Support\Facades\Validator;
use App\Managers\Team\TeamManager;


class AdminScheduleValidator
{
    public function __construct()
    {
        $this->team = new TeamManager();
    }
    public function add($data)
    {
        $validation = $validator = Validator::make(
                ['Date'             => trim($data['date_date']),
                 'Opposite Team'    => $data['opposite_team']],
                ['Date'             => 'required|date_format:Y-m-d',
                 'Opposite Team'    => 'required']
        );
        if ($validation->fails())
        {
            $errors = $validation->errors();
            $errors = $errors->toArray();
            
            foreach($errors AS $error)
            {
                $return['errors'][] = $error;
            }
            return $return;
        }
        
        
    }
    
    public function update($data, $UUID)
    {
        $validation = $validator = Validator::make(
                ['Date'             => trim($data['date_date']),
                 'Opposite Team'    => $data['opposite_team']],
                ['Date'             => 'required|date_format:Y-m-d',
                 'Opposite Team'    => 'required']
        );
        if ($validation->fails())
        {
            $errors = $validation->errors();
            $errors = $errors->toArray();
            
            foreach($errors AS $error)
            {
                $return['errors'][] = $error;
            }
            return $return;
        }
        
    }
    
    
    public function addSchedulePlayers($columns, $data)
    {
        if(empty($columns))
        {
            $return['errors'][] = 'You had added no Players';
            return $return;
        }
        
        $validation = $validator = Validator::make(
                ['Formation'             => trim($data['formation_id'])],
                ['Formation'             => 'required']
        );
        if ($validation->fails())
        {
            $errors = $validation->errors();
            $errors = $errors->toArray();
            
            foreach($errors AS $error)
            {
                $return['errors'][] = $error;
            }
            return $return;
        }
        
    }

    public function addScheduleLivePlayers($columns, $data)
    {
        if(empty($columns))
        {
            $return['errors'][] = 'You had added no Players';
            return $return;
        }
        
        $validation = $validator = Validator::make(
                ['Formation'             => trim($data['formation_id'])],
                ['Formation'             => 'required']
        );
        if ($validation->fails())
        {
            $errors = $validation->errors();
            $errors = $errors->toArray();
            
            foreach($errors AS $error)
            {
                $return['errors'][] = $error;
            }
            return $return;
        }
    }
}